#############################################################################
##
## (c) Genedata AG, Basel; profiler-helpdesk@genedata.com
##
#############################################################################


#' DataLake
#'
#' @description The DataLake R6 class provides provides methods to operate on
#' objects in the Data Lake of Genedata Profiler. The DataLake object is a sub-API
#' of the \code{\link[=ProfilerAPI]{ProfilerAPI}} and gets authorization
#' of the \code{\link[=ProfilerAPI]{ProfilerAPI}} and gets authorization
#' credentials from it's parent ProfilerAPI object. Please do not actively
#' create new sub-API objects, but call them via \code{ProfilerAPI$data_lake}.
#'
#' @section DataLake Method Overview:
#' The following functions can be used via \code{\link[=DataLake]{ProfilerAPI$data_lake$...}}:
#' \itemize{
#'  \item \code{list(folder_or_study_id, type = NULL, metadata = list(),
#'      recursive = FALSE, pattern = NULL, all_attributes = FALSE, fetch_size = 200)}:
#'      Lists all the objects of the specified type in the folder given by
#'      \code{folder_or_study_id}, optionally filtered by a name/path pattern.
#'      Optionally return all metadata attributes for all returned objects.
#'  \item \code{details(object_id)}: Provides information about an object, such
#'      as id, type, name, and update date and time.
#'  \item \code{create_folder(target_folder, name, sep = .Platform$file.sep)}:
#'      Creates a folder with name \code{name} in the specified
#'      target folder or study in the Data Lake. If the folder already exists,
#'      the name of the newly created folder will be made unique by adding a suffix.
#'  \item \code{upload_file(path, target_folder, name = basename(path), metadata = list(),
#'      source_ids = NULL, overwrite = NA, access_tags = NULL)}: Uploads a local file
#'      to a specified target folder or study in the Data Lake.
#'  \item \code{upload_data_frame(df, target_folder, name, metadata = list(),
#'      source_ids = NULL, sep = "\t", overwrite = NA, access_tags = NULL)}: Uploads a data frame
#'      as TSV file to a target folder in the Data Lake.
#'  \item \code{upload_multiple_files(files, target_folder, target_paths = NULL,
#'      metadata = list(), source_ids = list(), overwrite = NA, access_tags = list()}:
#'      Uploads multiple files to a folder in the Data Lake.
#'  \item \code{upload_folder(path, target_folder, name = basename(path), metadata = list(),
#'      source_ids = NULL, overwrite = NA, access_tags = NULL)}: Upload a folder including all of its contents
#'      to a target folder in the Data Lake.
#'  \item \code{download_file(file_id, path = ".", overwrite = FALSE,
#'      show_progress = TRUE)}: Downloads the content of the file to the specified
#'      \code{path}.
#'  \item \code{download_file_raw(file_id, show_progress=FALSE, max_bytes = Inf)}:
#'      Downloads the raw content of the file to memory.
#'  \item \code{download_folder(folder_id, path = ".", overwrite = FALSE,
#'      files_only = TRUE, show_progress = TRUE, include_pattern = NULL,
#'      exclude_pattern = NULL)}: Downloads the folder with all its contents to the
#'      specified \code{path}.
#'  \item \code{move(object_ids, target_folder)}: Move one or more Data Lake objects to another folder. The objects
#'      being moved can be files, folders, tables or views.
#'  \item \code{delete(..., delete_permanently = FALSE)}: Delete Data Lake objects corresponding to provided
#'      object IDs. By default, the deleted objects are put into the Recycle Bin and can be restored later.
#'      The \code{...} are concatenated to form one character string: you can specify the objects
#'      separately or as one vector. Note, the delete operation removes directories
#'      and their contents recursively. Objects that are inaccessible to the user are ignored.
#'  \item \code{object_id(study, path, ignore_case = FALSE,
#'      sep = .Platform$file.sep)}: Obtain the object id of an object based on
#'      the study's name/id and the path within the study.
#'  \item \code{search(query, limit = 1000, fetch_size = 200)}: Search for
#'      objects using the advanced search in Genedata Profiler.
#'  \item \code{list_archival_operations()}: Lists archival operations of objects whose storage class is being transitioned.
#'  \item \code{set_storage_class(ids, storage_class)}: Set storage class of file objects.
#'  \item \code{update_access_tags(access_tags}: Update access tags for one or more Data Lake objects.
#'  \item \code{metadata_add(ids, metadata)}: Add metadata to one or more Data Lake objects.
#'  \item \code{metadata_set(ids, metadata)}: Set metadata of one or more Data Lake objects.
#'  \item \code{metadata_remove(ids, metadata)}: Remove specific metadata values from of one or more Data Lake objects.
#'  \item \code{metadata_clear(ids, keys)}: Clear some or all metadata attributes associated to one or more Data
#'      Lake objects.
#' }
#'
#' @docType class
#' @seealso \link{ProfilerAPI}
#' @format An R6 class object.
#' @importFrom R6 R6Class
#' @import dplyr
#' @import tibble
#' @importFrom purrr map_dfr transpose
#' @importFrom stringr str_c
#' @importFrom R.utils getRelativePath getParent
#' @importFrom tidyr unnest unnest_wider
DataLake <- R6::R6Class("DataLake",
  cloneable = FALSE,

  private = list(
    upload_commit_timeout = 50,
    api = NULL,

    objects_url = function(object_id = NULL) {
        if (is.null(object_id)) {
            return(paste0(private$api$api_url, "/objects"))
        } else {
            check_object_id(object_id)
            return(paste0(private$api$api_url, "/objects/", object_id))
        }
    },

    upload_url = function(session_id = NULL) {
        if (is.null(session_id)) {
            return(paste0(private$objects_url(), "/upload"))
        } else {
            return(paste0(private$objects_url(), "/upload/", session_id))
        }
    },

    bulk_upload_url = function(session_id = NULL) {
        if (is.null(session_id)) {
            return(paste0(private$objects_url(), "/bulkUpload"))
        } else {
            return(paste0(private$objects_url(), "/bulkUpload/", session_id))
        }
    },

    start_bulk_upload_session = function(parent, rename) {
        response <- httr::POST(
          private$bulk_upload_url(),
          body = list(
            parent = parent,
            rename = rename
          ),
          encode = "json",
          config = private$api$token
        )
        check_response(response)
        httr::content(response, encoding = "UTF-8")$id
    },

    start_bulk_upload_file_session = function(session_id, path, name, metadata, source_ids, access_tag_ids) {
        response <- httr::POST(
          paste0(private$bulk_upload_url(session_id), "/file"),
          body = list(
            "path" = if (!is_empty(path) && path != ".") path else "",
            "name" = name,
            "metadata" = metadata,
            "sourceIds" = unname(source_ids),
            "accessTagIds" = unname(access_tag_ids)
          ),
          encode = "json",
          config = httr::config(token = private$api$token)
        )
        check_response(response)
        httr::content(response, encoding = "UTF-8")$id
    },

    upload_file_to_bulk_file_session = function(path, session_id, file_session_id) {
        url <- paste0(private$bulk_upload_url(session_id), "/file/", file_session_id)
        token <- private$api$token
        upload_file(path, url, token)
    },

    delete_bulk_upload_file_session = function(session_id, file_session_id) {
        delete_response <- httr::DELETE(
          paste0(private$bulk_upload_url(session_id), "/file/", file_session_id),
          config = private$api$token)
        check_response(delete_response)
    },

    commit_bulk_upload_session = function(session_id) {
        commit_response <- httr::POST(
            paste0(private$bulk_upload_url(session_id), "/commit"),
            config = httr::config(timeout_ms = private$upload_commit_timeout * 1000, token = private$api$token)
        )
        check_response(commit_response)
        response_content <- httr::content(commit_response, encoding = "UTF-8")
        poll_for_commit_resolution(response_content, private$bulk_upload_url(session_id), private$api$token)
        response_content
    },

    list_objects = function(query_parameters) {
        rest_response <- httr::GET(private$objects_url(), config = private$api$token, query = query_parameters)
        check_response(rest_response)
        response_content <- httr::content(rest_response, as = "text", type = "application/json", encoding = "UTF-8")
        tibble::as_tibble(jsonlite::fromJSON(response_content)$objects)
    },

    new_folder = function(folder_id, name) {
        tryCatch({
            response <- httr::POST(
              paste0(private$objects_url(), "/newFolder"),
              config = private$api$token,
              body = list(
                "parent" = folder_id,
                "name" = name
              ),
              encode = "json"
            )
        }, error = function(e) {
            e$message <- paste("Error creating folder: ", e, sep = " ") # nocov
            stop(e) # nocov
        })

        check_response(response)
        folder_attr <- httr::content(response, encoding = "UTF-8")
        setNames(folder_attr$id, folder_attr$name)
    },

    get_storage_root = function(study, study_group) {
        studies <- private$api$studies$list()
        if (!is.null(study_group)) {
            studies <- studies %>%
              filter(studyGroup == study_group)
        }

        storage_root <- studies %>%
          filter(name == study | id == study) %>%
          pull('storageRoot')
        if (length(storage_root) == 0) {
            stop("Study '", study, "' could not be found.", call. = FALSE)
        }
        if (length(storage_root) >= 2) {
            stop("Study '", study, "' could not be resolved unambiguously. There might be multiple studies with the same name in different study groups.", call. = FALSE) # nocov
        }
        storage_root
    },

    append_missing_parents = function(listing, root_folder_id) {
        # For listing with metadata
        child_to_parent <- as.list(listing$parent) %>% setNames(listing$id)
        children <- names(child_to_parent)

        orphan_to_missing_parent <- child_to_parent %>%
          purrr::discard(~ .x == root_folder_id) %>%
          purrr::discard(~ .x %in% children)

        if (length(orphan_to_missing_parent) > 0 ) {
            query_parameters <- list(folder = root_folder_id,
                                     recurse = 'true',
                                     type = 'folder')
            missing_parents <- private$list_objects(query_parameters) %>%
              tibble::as_tibble() %>%
              dplyr::filter(! id %in% children)
            if (nrow(missing_parents) > 0) {
                listing <- dplyr::bind_rows(listing, missing_parents)
            }
        }
        listing
    },

    create_relative_paths = function(listing, root_folder) {
        if (nrow(listing) > 0) {
            # if current version is equal or later than 16.4, skip the remaing part of this function
            listing %>%
              private$append_missing_parents(root_folder) %>%
              { if(utils::compareVersion(private$api$server_version,"16.4") >= 0) . else redirect_shared_folder_parents(., root_folder, private$api) } %>%
              create_relative_paths_from_complete_listing(root_folder) %>%
              head(nrow(listing)) # Only return paths for the original rows in listing
        } else {
            character(0)
        }
    },

    #' @description Modify metadata of one or more Data Lake objects.
    #' @param ids Character vector or list of object IDs whose metadata should be modified.
    #' @param metadata Named list containing the metadata attributes and values to be modified. Note that metadata values
    #' per attribute can be provided as a single character value or a vector.
    #' @param mode Specifies the modification mode. Available options are "add", "remove", "set", and "clear".
    #' Mode 'add' appends the metadata values to the given attribte. Mode 'set' replaces all vales of
    #' a metadata key. Mode 'remove' deletes all provided values from the corresponding key. Mode 'clear' deletes
    #' all metadata attributes and values from the specified objects.
    #'
    modify_metadata = function(ids, metadata = NULL, mode = "add") {
        require_profiler_version("16.0.6", "data lake edit metadata", private$api)
        object_ids <- unlist(list(ids))
        stopifnot(is.character(object_ids))
        stopifnot(tolower(mode) %in% c("add", "remove", "set", "clear"))
        stopifnot(tolower(mode) == "clear" || is.list(metadata))

        keys_with_empty <- purrr::keep(metadata, ~ '' %in% .x)
        if (length(keys_with_empty) > 0){
            warning('Ignoring empty or missing values in keys: ', purrr::reduce(names(keys_with_empty), ~paste(.x, .y, sep = ', ')), '.')
        }

        md <- metadata %>%
          purrr::modify_if(~ !is.list(.x), as.list) %>%
          purrr::map(~ purrr::discard(.x, ~ is.null(.x))) %>%  # drop NULL
          purrr::map(~ purrr::discard(.x, ~ is.na(.x))) %>%    # drop NAs
          purrr::map(~ purrr::discard(.x, ~ .x == ''))         # drop empty strings

        # add and remove don't allow for sending empty value lists
        if (mode %in% c("add", "remove")) {
            md <- purrr::discard(md, ~ length(.x) == 0)
        }

        if (!is.null(object_ids) && length(object_ids) > 0) {
            response <- httr::POST(
              paste0(private$objects_url(), "/metadata"),
              body = list(
                ids = unname(as.list(object_ids)),
                mode = mode,
                metadata = md
              ),
              encode = "json",
              config = private$api$token
            )
            check_response(response)
        }

        invisible(self)
    },

    ensure_upload_folder = function(parent_folder_id, name, overwrite) {
        if (!is.na(overwrite)) {
            existing_folder <- get_object_id_by_path(parent_folder_id, name, private$api)
            if (!is.null(existing_folder)) {
                if (overwrite) {
                    cli::cli_alert_info("Folder {name} already exists in Data Lake folder {parent_folder_id} and will be moved to the Recycle Bin.")
                    self$delete(existing_folder)
                } else {
                    cli::cli_abort("Folder {name} already exists in Data Lake folder {parent_folder_id}.", call = NULL)
                }
            }
        }
        private$new_folder(parent_folder_id, name)
    },

    ensure_safe_target =  function(target_folder, object_ids){
        if (target_folder %in% object_ids){
            cli::cli_abort("Folder with id={target_folder} cannot be moved onto itself.", call = NULL)
        }

        folder_content <- private$api$data_lake$list(target_folder)$id
        existing_objects <- intersect(folder_content, object_ids)
        if (length(existing_objects) != 0){
            for (object_id in existing_objects){
                cli::cli_alert_warning("Object with id={object_id} already exists in target folder.")
            }
        }
    }

  ),

  public = list(

    #' @description
    #' Create a new DataLake object.
    #' @param api An instance of a \code{\link[=ProfilerAPI]{ProfilerAPI}} object.
    initialize = function(api) {
        stopifnot(inherits(api, "ProfilerAPI"))
        private$api <- api
    },

    #' @description
    #' Prints the DataLake object.
    #' @param ... All extra arguments from a print(obj, ...) call are passed on to the obj$print(...) method.
    print = function(...) {
        cat("<DataLake>\n", sep = "")
        invisible(self)
    },

    #' @description Lists all the objects of the specified type in the folder.
    #' @param folder_or_study_id The folder or study id for which objects should
    #'   be listed. If the \code{folder_or_study_id} is a study id, then all
    #'   objects in the study's root folder are listed.
    #' @param type Allowed types are "file", "folder", "table", "view",
    #'   "processedData", and NULL. If the \code{type} is NULL, all object types
    #'   will be listed.
    #' @param metadata The \code{metadata} parameter allows to optionally filter
    #'   by matching metadata key-value pairs, which should be provided as a
    #'   named list.
    #' @param recursive Recursively list objects in subfolders. FALSE by default.
    #' @param pattern Optional pattern to filter the resulting object list. See
    #'  the pattern option in \code{\link[stringr:str_detect]{stringr::str_detect}}
    #'  for more information.
    #' @param all_attributes Should all metadata attributes and access tags be included in the
    #'   result?
    #' @param fetch_size Result objects are fetched in chunks of provided size.
    #' The maximum chunk size is 1000 (default: 200)
    #' @return Returns a tibble of accessible objects with the following columns:
    #' id, name, type, lastUpdated, and parent.
    list = function(folder_or_study_id, type = NULL, metadata = list(), recursive = FALSE, pattern = NULL,
                    all_attributes = FALSE, fetch_size = 200) {
        check_required_parameter(folder_or_study_id, "folder_or_study_id",
                                 "If a valid study id is provided, objects in the study's root folder will be listed.")
        check_metadata(metadata)
        stopifnot(is.logical(recursive))
        object_type <- if(is.null(type)) NULL else match.arg(type, choices = c("file", "folder", "table", "view", "processedData"))

        metadata <- update_metadata_for_filter_query(metadata)

        folder_id <- to_folder_id(folder_or_study_id, private$api)

        query_parameters <- metadata  # this is already a (maybe empty) list
        query_parameters["folder"] <- folder_id
        query_parameters["recurse"] <- tolower(as.character(recursive))
        if (!is.null(type) && (!recursive || type == 'folder')) {
            query_parameters["type"] <- object_type
        }

        result <- private$list_objects(query_parameters)
        # ensure column presence and order
        columns <- tibble::tibble(
          id = character(0),
          name = character(0),
          path = character(0),
          type = character(0),
          lastUpdated = character(),
          parent = character(0),
          creator = character(0),
          created = character(),
          studyId =  character(0),
          studyName = character(0),
          studyGroup =  character(0),
          studyDescription =  character(0)
        )

        res <- dplyr::bind_rows(columns, tibble::as_tibble(result)) %>%
            # path creation should come before filtering by type/path to ensure all required parent paths exist
            dplyr::mutate(path = private$create_relative_paths(., folder_id), .after="name") %>%
            filter_name_or_id_by_pattern(pattern) %>%
            dplyr::filter(is.null(object_type) | type %in% object_type)

        if (nrow(res) == 0){
            return(res)
        }

        if (all_attributes) {
            res <- list_with_all_attributes(res$id, private$objects_url(), private$api$token, fetch_size) %>%
              # add back the paths, that have been created before applying filtering
              tibble::add_column(path = res$path, .after = 'name')
        }

        res %>% convert_datetimes_tibble(names = c("lastUpdated", "created"))
    },

    #' @description Provides information about an object, such as id, type,
    #' name, and update date and time. For information about views see
    #' \code{\link[=AnalyticsViews]{api$analytics_views$details()}}.
    #' @param object_id The object id of the object.
    #' @return Returns a named list, listing object details such as its id,
    #'   type, name, accessTags and update date and time. For files and tables additionally
    #'   parent folder and metadata. For folders additionally the folder
    #'   content. For processedData the parent folder, metadata, dataSets, and
    #'   attachments.
    details = function(object_id) {
        # this REST endpoint only works with proper object IDs, not view ids
        rest_response <- httr::GET(private$objects_url(object_id), config = private$api$token)
        check_response(rest_response)

        response_content <- httr::content(rest_response, as = "text", type = "application/json", encoding = "UTF-8")
        convert_datetimes_list(jsonlite::fromJSON(response_content), names = c("lastUpdated", "created"))
    },

    #' @description Creates a folder with name \code{name} in the specified
    #'  \code{target_folder} or study in the Data Lake. If the folder already exists,
    #'  the name of the newly created folder will be made unique by adding a suffix.
    #' @param target_folder A Data Lake folder id or a study id in which
    #'   the new folder should be created.
    #' @param name The name of the folder to be created. If a folder with
    #'   the same name already exists in the target folder, the new folder name will be a
    #'   appended with a number suffix to make it unique. The folder name can also be a
    #'   path to create several folders below the specified \code{target_folder}.
    #' @return Returns a named character vector containing the name and folder id of the
    #'   newly created folder.
    create_folder = function(target_folder, name) {
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        check(checkmate::check_string(name, min.chars = 1), "name")

        parent_folder_id <- to_folder_id(target_folder, private$api)
        segments <- clean_path_segments(name)

        purrr::reduce(segments, function(parent, path_segment) {
            private$new_folder(unname(parent), path_segment)
        }, .init = parent_folder_id)
    },

    #' @description Uploads a local file to a specified target folder or study in the Data Lake.
    #' @param path The path of the file to be uploaded.
    #' @param target_folder The folder id of the Data Lake folder to which the file should be
    #'   uploaded. If a valid study id is provided, the file will be uploaded to the study's root
    #'   folder.
    #' @param name The name of the new file in the Data Lake. Defaults to the basename of the file path
    #'   specified in \code{path}.
    #' @param metadata The file can optionally be tagged with metadata in the
    #'   Data Lake. If \code{metadata} are specified, this must be a named list.
    #' @param source_ids Optional A vector of source ids for the uploaded file to maintain object provenance.
    #' Source ids are a list of object ids of objects from which the uploaded file is derived.
    #' @param overwrite Logical, indicating whether to check for a pre-existing file
    #'   with the same name in the target folder.
    #' \itemize{
    #'    \item{`NA` (default):} {Just do the upload. In case of pre-existing file(s), the file is
    #'      automatically renamed by appending [1] to the file name.}
    #'   \item{`TRUE`:} {Check for a pre-existing file with the specified name in the target folder.
    #'     If there is one, move the pre-existing file to the Recycle Bin, then carry on. Note
    #'     that the new file does not inherit any metadata attributes from the old one. It will
    #'     have a new file ID.}
    #'   \item{`FALSE`:} {Error if there is any pre-existing file with the specified name in the target
    #'      folder.}
    #' }
    #' @param access_tags Optional. Either a vector of access tag ids or a data.frame of access tags as returned by
    #'   \code{\link[=DataLake]{details()}}.
    #' @return Returns the a named vector containing the name and object id of the uploaded file.
    upload_file = function(path, target_folder, name = basename(path), metadata = list(), source_ids = NULL,
                                   overwrite = NA, access_tags = NULL) {
        check(checkmate::check_string(path, min.chars = 1), "path")
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        check(checkmate::check_string(name, min.chars = 1), "name")
        check_access_tags(access_tags)
        check(checkmate::check_flag(overwrite, na.ok = TRUE), "overwrite")
        check_file_path(path)

        folder_id <- to_folder_id(target_folder, private$api)
        apply_overwrite_policy(name, folder_id, overwrite, private$api)

        tryCatch({
            additional_params <- if (is.na(overwrite)) list(rename = TRUE) else list()
            if (!is.null(access_tags)) {
                additional_params$accessTagIds <- get_access_tag_ids(access_tags)
            }
            session_id <- start_upload_session(private$upload_url(), folder_id, name, metadata, source_ids, private$api$token,
                                               additional_params = additional_params)
            session_url <- private$upload_url(session_id)
            upload_file_to_session(path, session_url, private$api$token)
            file_id <- commit_upload_session(session_url, private$api$token)$id
            names(file_id) <- self$details(file_id)$name
        }, error = function(e) {
            e$message <- paste("Failed to upload file:", e) # nocov
            stop(e) # nocov
        })

        file_id
    },

    #' @description Uploads a data frame as TSV file to a target folder in the
    #'   Data Lake.
    #' @param df The data frame to be uploaded.
    #' @param target_folder The folder id of the Data Lake folder to which the file should be
    #'   uploaded. If a valid study id is provided, the file will be uploaded to the study's root
    #'   folder.
    #' @param name The name of the new file in the Data Lake.
    #' @param metadata The file can optionally be tagged with metadata in the
    #'   Data Lake. If \code{metadata} are specified, this must be a named list.
    #' @param source_ids An optional vector of source ids for the uploaded file to maintain object provenance.
    #' Source ids are object ids of objects from which the uploaded file is derived.
    #' @param sep By default, the data frame is uploaded as a tab-separated
    #'   file, but the separator can be changed by setting \code{sep} e.g. to
    #'   "," for a comma-separated file (CSV).
    #' @param overwrite Logical, indicating whether to check for a pre-existing file
    #'   with the same name in the target folder.
    #' \itemize{
    #'   \item{`NA` (default):} {Just do the upload. In case of pre-existing file(s), the file is
    #'      automatically renamed by appending [1] to the file name.}
    #'   \item{`TRUE`:} {Check for a pre-existing file with the specified name in the target folder.
    #'     If there is one, move the pre-existing file to the Recycle Bin, then carry on. Note
    #'     that the new file does not inherit any metadata attributes from the old one. It will
    #'     have a new file ID.}
    #'   \item{`FALSE`:} {Error if there is any pre-existing file with the specified name in the target
    #'      folder.}
    #' }
    #' @param access_tags Optional. Either a vector of access tag ids or a data.frame of access tags as returned by
    #'   \code{\link[=DataLake]{details()}}.
    #' @return Returns the a named vector containing the name and object id of the uploaded file.
    #' @importFrom utils write.table
    upload_data_frame = function(df, target_folder, name, metadata = list(), source_ids = NULL, sep = "\t",
                                 overwrite = NA, access_tags = NULL) {
        check(checkmate::check_data_frame(df), "df")
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        check(checkmate::check_string(name, min.chars = 1), "name")
        check(checkmate::check_string(sep, min.chars = 1, max.chars = 1), "sep")
        check_access_tags(access_tags)
        check(checkmate::check_flag(overwrite, na.ok = TRUE), "overwrite")
        check_required_parameter(target_folder, "folder_or_study_id")
        check_required_parameter(df, "df")
        check_required_parameter(name, "name")
        check(checkmate::check_flag(overwrite, na.ok = TRUE), "overwrite")

        path <- tempfile(pattern = name, tmpdir = tempdir(), fileext = ".tsv")
        utils::write.table(df, file = path, sep = sep, row.names = FALSE)

        self$upload_file(
          path,
          target_folder,
          name = name,
          metadata = metadata,
          source_ids = source_ids,
          access_tags = get_access_tag_ids(access_tags),
          overwrite = overwrite
        )
    },

    #' @description Uploads multiple files to the Data Lake
    #' @param files Character vector of local file paths to be uploaded.
    #' @param target_folder The target folder id, or a study id, where
    #'   the files should be uploaded to. If a valid study id is provided
    #'   instead of a folder id, the file will be uploaded to the study's root
    #'   folder.
    #' @param target_paths A character vector of same length as \code{files} with the
    #'   target file paths (including file name) in the Data Lake. By default, the filenames
    #'   of the local file paths provided in \code{files} will be used as target paths.
    #' @param metadata The file can optionally be tagged with metadata in the
    #'   Data Lake. If \code{metadata} are specified, this must be a named list.
    #' @param source_ids An optional list of vectors with source ids for each of the uploaded file(s) to maintain
    #' object provenance. Source ids are object ids of objects from which the uploaded file(s) are derived.
    #' @param overwrite Logical, indicating whether to check for a pre-existing file
    #'   with the same name in the target folder.
    #' \itemize{
    #'   \item{`NA` (default):} {Just do the upload. In case of pre-existing file(s), the file is
    #'      automatically renamed by appending [1] to the file name.}
    #'   \item{`TRUE`:} {Check for a pre-existing file with the specified name in the target folder.
    #'     If there is one, move the pre-existing file to the Recycle Bin, then carry on. Note
    #'     that the new file does not inherit any metadata attributes from the old one. It will
    #'     have a new file ID.}
    #'   \item{`FALSE`:} {Error if there is any pre-existing file with the specified name in the target
    #'      folder.}
    #' }
    #' @param access_tags An optional list of vectors with access tag ids or a data.frame of access tags as returned in
    #'   the object details function, for each of the uploaded file(s).
    #' @return Returns TRUE in case the upload was successful.
    upload_multiple_files = function(files, target_folder, target_paths = NULL, metadata = list(), source_ids = list(),
                                     overwrite = NA, access_tags = list()) {
        check(checkmate::check_character(files, min.chars = 1), "files")
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        check(checkmate::check_list(source_ids, names=NULL, null.ok=T), "source_ids")
        check(checkmate::check_flag(overwrite, na.ok = TRUE), "overwrite")
        purrr::walk(access_tags, check_access_tags)
        purrr::walk(files, check_file_path)

        folder_id <- to_folder_id(target_folder, private$api)
        full_target_paths <- files %>%
          purrr::imap_chr(function(f, i) ifelse(is.null(purrr::pluck(target_paths, i)), basename(f), purrr::pluck(target_paths, i))) %>%
          apply_overwrite_policy(folder_id, overwrite, private$api)

        session_id <- private$start_bulk_upload_session(folder_id, rename = is.na(overwrite))
        file_session_id <- NULL

        for (i in seq_along(files)) {
            tryCatch({
                name <- basename(full_target_paths[i])
                path <- dirname(full_target_paths[i])
                md <- purrr::pluck(metadata, i) %>%
                  purrr::map(unlist) %>%
                  purrr::map(unname) %>%
                  check_metadata()
                src_ids <- as.list(purrr::pluck(source_ids, i))
                file_access_tags <- purrr::pluck(access_tags, i)
                access_tag_ids <- get_access_tag_ids(file_access_tags)

                file_session_id <- private$start_bulk_upload_file_session(session_id, path, name, md, src_ids, access_tag_ids)
                private$upload_file_to_bulk_file_session(files[i], session_id, file_session_id)

            }, error = function(e) {
                if (!is.null(file_session_id)) {
                    private$delete_bulk_upload_file_session(session_id, file_session_id)
                }
                cli::cli_abort(paste("Error uploading file:", e), call = NULL)
            })
        }

        tryCatch({
            private$commit_bulk_upload_session(session_id)
        }, error = function(e) {
            if (is_timeout_error(e) && compareVersion(private$api$server_version, "16.0.0") < 0) {
                poll_for_files_to_finish(folder_id, full_target_paths, self)
            } else {
                cli::cli_abort(paste("Error committing bulk upload:", e), call = NULL)
            }
        })

        cli::cli_alert_success("Uploaded {length(files)} file{?s}.")
        invisible(TRUE)
    },

    #' @description Upload a folder including all of its contents to the specified target
    #'   folder in the Data Lake. The folder contents of the local folder are replicated in
    #'   the Data Lake, except that empty sub-folders are ignored.
    #' @param path Path to a local folder to be uploaded.
    #' @param target_folder The target folder id, or study id, to which
    #'   the folder should be uploaded. If a valid study id is provided
    #'   instead of a folder id, the file will be uploaded to the study's root
    #'   folder.
    #' @param name The name of the folder in the data lake. By default,
    #'   the name of the last path element of the specified folder path will be
    #'    used as folder name in the data lake.
    #' @param metadata The uploaded files can optionally be tagged with
    #'   metadata in the data lake. If \code{metadata} are specified, this must
    #'   be a named list. All uploaded files will get the same set of metadata.
    #' @param source_ids An optional vector of source ids, which will be used for all uploaded files to
    #'   maintain object provenance. Source ids are object ids of objects from which the uploaded file(s) are derived.
    #' @param overwrite Logical, indicating whether to check for a pre-existing folder
    #'   with the same name in the target folder.
    #' \itemize{
    #'   \item{`NA` (default):} {Just do the upload. In case of pre-existing folder(s) with the same
    #'      name, the folder is automatically renamed by appending [1] to its name.}
    #'   \item{`TRUE`:} {Check for a pre-existing folder with the specified name in the target folder.
    #'     If there is one, move the pre-existing folder to the Recycle Bin, then carry on. Note
    #'     that the new folder and it's file contents will have new object IDs.}
    #'   \item{`FALSE`:} {Error if there is any pre-existing folder with the specified name in the target
    #'      folder.}
    #' }
    #' @param access_tags Optional. Either a vector of access tag ids or a data.frame of access tags as returned by
    #'   \code{\link[=DataLake]{details()}} that will be applied to all files.
    #' @return Returns the a named vector containing the name and object id of the uploaded file.
    upload_folder = function(path, target_folder, name = basename(path), metadata = list(), source_ids = NULL,
                             overwrite = NA, access_tags = NULL) {
        check(checkmate::check_string(path, min.chars = 1), "path")
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        check(checkmate::check_string(name, min.chars = 1), "name")
        check_access_tags(access_tags)
        check(checkmate::check_flag(overwrite, na.ok = TRUE), "overwrite")
        check_folder_path(path)

        target_folder_id <- to_folder_id(target_folder, private$api)
        upload_folder_id <- private$ensure_upload_folder(target_folder_id, name, overwrite)
        files <- list.files(path, full.names = TRUE, recursive = TRUE)
        target_paths <- purrr::map(files, ~ R.utils::getRelativePath(.x, path))

        # Upload all files to the newly created upload folder
        self$upload_multiple_files(
          files = files,
          target_folder = upload_folder_id,
          target_paths = target_paths,
          metadata = purrr::map(files, ~ metadata),
          source_ids = purrr::map(files, ~ source_ids),
          access_tags = purrr::map(files, ~ access_tags),
          overwrite = NA
        )
        upload_folder_id
    },

    #' @description Downloads the content of the file to the specified local
    #' \code{path}.
    #' @param file_id The file id of the file to be downloaded.
    #' @param path By default, the file will be downloaded to the current
    #'   working directory.
    #' @param overwrite Should existing destination files be overwritten or silently
    #'   skipped? Default FALSE.
    #' @param show_progress If \code{show_progress} is \code{TRUE} an
    #'   interactive progress bar is shown.
    download_file = function(file_id, path = ".", overwrite = FALSE, show_progress = TRUE) {
        check_required_parameter(file_id, "file_id")
        check_required_parameter(path, "path", "This should be either an absolute or relative path to where the file should be saved. If no filename is specified (just a folder), the filename from the objectstore will be used.")
        check_download_path(path)

        details <- self$details(file_id)

        ensure_file(details$type, file_id)

        if (file_test("-d", path)) {
            filename <- details$name
            path <- file.path(path, filename)
        }
        url <- paste0(private$objects_url(file_id), '/fetch')
        if (file_test("-f", path) && !overwrite) {
            return(path)
        }

        tryCatch({
            if (show_progress) { # nocov start
                response <- httr::GET(
                  url,
                  config = private$api$token,
                  httr::write_disk(path = path, overwrite = overwrite),
                  httr::progress()
                ) # nocov end
            } else {
                response <- httr::GET(
                  url,
                  config = private$api$token,
                  httr::write_disk(path = path, overwrite = overwrite)
                )
            }
            check_response(response)
        }, error = function(e) {
            # clean-up accidentally created file on disk that contains only REST error message
            if (file.exists(path)) {
                file.remove(path)
            }
            e$message <- paste("Downloading file with id '", file_id, "' to path '", path, "' failed:", e, sep = " ")
            # and re-raise
            stop(e)
        })

        path
    },

    #' @description Downloads the raw content of the file to memory.
    #' @param file_id The file id of the file to be downloaded.
    #' @param show_progress If \code{show_progress} is \code{TRUE} an
    #'   interactive progress bar is shown.
    #' @param max_bytes Maximum number of bytes to read. Supply `Inf` to read the whole file.
    #' You can use this parameter to effectively peek into the first bytes of a large file.
    download_file_raw = function(file_id, show_progress = FALSE, max_bytes = Inf) {
        check_required_parameter(file_id, "file_id")
        check(checkmate::check_number(max_bytes, lower=1), "max_bytes")

        range_header <- NULL
        if (!is.infinite(max_bytes) && max_bytes > 0) {
           range_header <- c(Range = glue::glue("bytes=0-{as.integer(max_bytes)}"))
        }

        tryCatch({
            url <- paste0(private$objects_url(file_id), '/fetch')
            if (show_progress) { # nocov start
                response <- httr::GET(
                  url,
                  config = private$api$token,
                  httr::write_memory(),
                  httr::progress(),
                  httr::add_headers(range_header)
                )
            } else { # nocov end
                response <- httr::GET(
                  url,
                  config = private$api$token,
                  httr::write_memory(),
                  httr::add_headers(range_header)
                )
            }
        }, error = function(e) {
            e$message <- paste("Error downloading file: ", e, sep = " ") # nocov
            stop(e) # nocov
        })
        check_response(response)

        httr::content(response, as = "raw")
    },


    #' @description
    #' Downloads a folder with all it's content.
    #' @param folder_id The folder id of the folder to be downloaded
    #' @param path By default, the file will be downloaded to the current
    #'   working directory.
    #' @param overwrite Should existing destination files be overwritten or silently
    #'  skipped? Default FALSE.
    #'  Please note: if true and the target directory already exists with contents,
    #'  only identically named files will be replaced, and other previously
    #'  existing files will remain unchanged.
    #' @param files_only Objects of type other than `file` or `folder` are not
    #'  downloadable. If the specified folder contains such objects and this
    #'  parameter is set to FALSE, the download will fail. Set this parameter to
    #'  TRUE to avoid this error.
    #' @param show_progress Should the process (measured in number of downloaded
    #'  objects) be shown?
    #' @param include_pattern Optionally restrict the download to only those files and
    #'  folders matching the provided include pattern.
    #'  See the pattern option in \code{\link[stringr:str_detect]{stringr::str_detect}}
    #'  for more information. Mutually exclusive with `exclude_pattern`.
    #' @param exclude_pattern Optionally exclude files and folder matching the provided
    #'  pattern from the download.
    #'  See the pattern option in \code{\link[stringr:str_detect]{stringr::str_detect}}
    #'  for more information. Mutually exclusive with `include_pattern`.
    download_folder = function(folder_id, path = ".", overwrite = FALSE, files_only = TRUE, show_progress = TRUE,
                               include_pattern = NULL, exclude_pattern = NULL) {
        check_required_parameter(study, "folder_id")
        check_required_parameter(path, "path")
        stopifnot(is.null(include_pattern) || is.null(exclude_pattern))

        folder_name <- self$details(folder_id)$name
        download_path <- file.path(path, folder_name)
        objects <- self$list(folder_id, recursive = TRUE)

        objects <- objects %>%
          mutate(relative_path = private$create_relative_paths(., folder_id)) %>%
          filter(type != 'folder')

        if (!is.null(include_pattern)) {
            objects <- objects %>% filter(matches_path(relative_path, include_pattern))
        } else if (!is.null(exclude_pattern)) {
            objects <- objects %>% filter(!matches_path(relative_path, exclude_pattern))
        }

        if (files_only) {
            objects <- objects %>% filter(type == 'file')
        }

        suppressWarnings(pb <- dplyr::progress_estimated(nrow(objects)))
        purrr::walk2(objects$id, objects$relative_path, function(file_id, relative_path) {
            file_path <- file.path(download_path, relative_path)
            fs::dir_create(dirname(file_path), recurse = TRUE)
            self$download_file(file_id = file_id, path = file_path, overwrite = overwrite, show_progress = FALSE)
            if (show_progress) {
                pb$tick()$print()
            }
        })

        download_path
    },

    #' @description
    #' Returns an object_id based on an object's location within a study. Returns
    #' NA in case an object with the specified path and name does not exist.
    #' @param study The study where the object is located. Both name and id are valid.
    #' @param path The path of the object within the study.
    #' @param ignore_case Should the search be done case-insensitive?
    #' @param study_group Optional: the study group (studies can be named identically when they belong to different groups).
    #' @returns The object id based on the path of an object inside a study.
    object_id = function(study, path, ignore_case = FALSE, study_group = NULL) {
        check_required_parameter(study, "study")
        check_required_parameter(path, "path")

        storage_root <- private$get_storage_root(study, study_group)
        obj_id <- get_object_id_by_path(storage_root, path, private$api, ignore_case = ignore_case)
        if (is.null(obj_id)) {
            cli::cli_alert_warning("Path {path} could not be resolved to an object ID.")
        }

        obj_id
    },

    #' @description
    #' Search for Data Lake objects across studies using an Advanced Search query in Genedata Profiler.
    #' @param query A filter query as shown in the data portal Advanced Search, e.g.
    #' "Name CONTAINS .tsv" or "Age IS_PRESENT".
    #' @param limit Limit the number of retrieved objects matching the search query.
    #' Use limit = Inf to retrieve all result objects (default: 1000).
    #' @param fetch_size Result objects are fetched in chunks of provided size.
    #' The maximum chunk size is 1000 (default: 200)
    #' @returns A tibble containing result objects matching the provided search query, including all metadata.
    search = function(query, limit = 1000, fetch_size = 200) {
        require_profiler_version("15.99.99", "advanced search", private$api)
        stopifnot(is.numeric(limit), length(limit) == 1)
        stopifnot(is.numeric(fetch_size), fetch_size > 0, fetch_size <= 1000, length(fetch_size) == 1)
        if (limit <= 0) {
            limit <- Inf
        }

        tryCatch({
            response <- httr::POST(
              paste0(private$objects_url(), "/query"),
              body = list(
                "query" = query,
                "limit" = NULL # for now, do not apply limit here, but on result set
              ),
              encode = "json",
              config = private$api$token
            )
            check_response(response)
        }, error = function(e) {
            if (is_timeout_error(e)) {
                e$message <- paste(e, "Consider refining your search query to be more specific.", sep = "\n") # nocov
            }
            stop(e)
        })

        ids <- httr::content(response, encoding = "UTF-8")$ids
        total_size <- length(ids)
        if (total_size == 0) {
            # contains only base columns, that apply to all data types
            return(tibble::tibble(
              id = character(),
              type = character(),
              name = character(),
              creator = character(),
              created = character(0),
              lastUpdated = character(),
              parent = character(0),
              studyId = character(0),
              studyName = character(0),
              studyGroup = character(0),
              studyDescription = character(0),
            ))
        }
        if (total_size > limit) {
            ids <- ids[1:limit]
            warning("Only first ", format(limit, big.mark = ","), " out of ", format(total_size, big.mark = ","),
                    " results retrieved. Use limit = Inf to retrieve all.", call. = FALSE)
        }

        list_with_all_attributes(ids, private$objects_url(), private$api$token, fetch_size) %>%
          convert_datetimes_tibble(names = c("lastUpdated", "created"))
    },

    #' @description Delete one or more Data Lake objects. The delete operation removes
    #' directories and their contents recursively. Objects that are inaccessible to the
    #' user are ignored.
    #' @param ... The object IDs of objects to be deleted. The provided arguments are
    #' concatenated to form one character string: you can specify the objects
    #' separately or as one vector.
    #' @param delete_permanently If FALSE, objects are put into the Recycle Bin and are recoverable.
    #' Otherwise, the deletion is permanent and cannot be undone.
    #' @return Returns a logical vector indicating which of the input object IDs were
    #' actually deleted.
    delete = function(..., delete_permanently = FALSE) {
        object_ids <- unname(unlist(list(...)))
        if (is.null(object_ids) || length(object_ids) == 0) {
            return(object_ids)
        }
        stopifnot(is.character(object_ids))
        ensure_rest_scope('DELETE', private$api$allowed_scopes)

        response <- httr::POST(
          paste0(private$objects_url(), if (delete_permanently) "/hardDelete" else "/delete"),
          body = list(ids = as.list(object_ids)),
          encode = "json",
          config = private$api$token
        )
        check_response(response)

        deleted_ids <- unlist(httr::content(response, encoding = "UTF-8")$ids)
        is_deleted <- object_ids %in% deleted_ids

        object_ids[!is_deleted] %>%
          purrr::walk(~ warning(glue::glue("Cannot delete '{.x}', reason 'No such {type}, or possibly no access'",
                                           type = strsplit(.x, "-", fixed = TRUE)[[1]][1]), call. = FALSE))

        is_deleted
    },

    #' @description Move one or more Data Lake objects to another folder. The objects being moved
    #' can be files, folders, tables or views.
    #' @param object_ids The object or folder IDs of objects to be moved.
    #' @param target_folder The destination folder ID.
    move = function(object_ids, target_folder) {
        check(checkmate::check_character(object_ids, min.len = 1, min.chars = 1), "object_ids")
        check(checkmate::check_string(target_folder, min.chars = 1), "target_folder")
        ensure_rest_scope('DATA_LAKE', private$api$allowed_scopes)
        private$ensure_safe_target(target_folder, object_ids)

        response <- httr::POST(
          paste0(private$objects_url(), "/move"),
          body = list(
            ids = as.list(object_ids),
            dest = target_folder
          ),
          encode = "json",
          config = private$api$token
        )
        check_response(response)

        invisible(self)
    },

    #' @description Lists archival operations of objects whose storage class is being transitioned.
    #' The transition may fail, in which case the error will be available in the `status` column of the tibble.
    #' In case of an error, the transition will be retried 24 hours later, for a maximum of five retries.
    #' In the event of all retries being exhausted, the `startTime` will be set to `NA`, and the status to failure.
    #' The record of a failed transition may either be removed in the UI, or by resubmitting a transition for that
    #' object.
    #'
    #' For more information about storage classes see the
    #' \href{https://aws.amazon.com/s3/storage-classes/}{Amazone Storage Classes} documentation.
    #' Note: User requires the system permission 'Change storage tier of object in the data lake',
    #' and the Profiler system requires the 'Profiler Data Tier' license key.
    #' @return Returns a tibble of ongoing or scheduled archival operations. The tibble contains the
    #' following columns:
    #' id, submissionTime, startTime, destinationClass, status.
    #' The `startTime` refers to the start of an ongoing transition, or the next scheduled one. If a transition has
    #' failed, the start time will be set to `NA`.

    list_archival_operations = function() {
        require_profiler_version("16.6", "object archival", private$api)
        rest_response <- httr::GET(
          paste0(private$objects_url(), "/archival-operations"),
          config = private$api$token
        )
        check_response(rest_response)
        columns <- tibble::tibble(
          id = character(0),
          destinationClass = character(0),
          submissionTime = character(0),
          startTime = character(0),
          status = character(0)
        )
        rest_response %>%
          httr::content(as = "text", type = "application/json", encoding = "UTF-8") %>%
          jsonlite::fromJSON() %>%
          purrr::pluck("status") %>%
          tibble::as_tibble() %>%
          dplyr::bind_rows(columns, .) %>%
          convert_datetimes_tibble(names=c("startTime", "submissionTime"))
    },

    #' @description Set storage class of file objects.
    #' The function starts the transistion process, which may take hours or days to complete.
    #' To observe the state of the transition, see the `list_archival_operations` function.
    #' For more information on storage classes, please see the
    #' \href{https://aws.amazon.com/s3/storage-classes/}{Amazon Storage Classes} documentation.
    #' Note: User requires the system permission 'Change storage tier of object in the data lake',
    #' and the Profiler system requires the 'Profiler Data Tier' license key.
    #' @param ids Character vector or list of object IDs of which the storage class will be set.
    #' Note that the storage class features are only applicable to file objects, i.e. not analytics tables
    #' nor views.
    #' @param storage_class String specifiying the storage class to which the objects will be transissioned.
    #' As of Profiler 16.6.0. the storage classes 'Standard', 'Standard-IA', 'Glacier Instant Retrieval', and
    #' 'Glacier Deep Archive' are supported.
    set_storage_class = function(ids, storage_class) {
        require_profiler_version("16.6", "object archival", private$api)
        object_ids <- unlist(list(ids))
        stopifnot(is.character(object_ids))
        stopifnot(is.character(storage_class) && length(storage_class) == 1)

        rest_response <- httr::POST(
          paste0(private$objects_url(), "/archival-operations"),
          body = list(
            ids = unname(as.list(object_ids)),
            storageClass = storage_class
          ),
          encode = "json",
          config = private$api$token
        )
        check_response(rest_response)
        cat(
          glue::glue(
              "Successfully started the transfer of objects to storage class {storage_class}.",
              storage_class=storage_class
            )
        )
        invisible(self)
    },

    #' @description Update access tags for one or more Data Lake objects.
    #' Note: The provided access tags will replace existing ones. Hence, providing an empty numeric vector
    #' or an empty data.frame of access tags for an object will remove the access tags for this object.
    #' See also the "Best Practices" section in the vignette for examples.
    #' @param access_tags Named list of access tags where the names are the object ids.
    #' Access tags can be provided either as a numeric vector of access tag ids or a data.frame of access tags as
    #' returned by \code{\link[=DataLake]{details()}}.
    #' Note: Available access tags can be listed via \code{\link[=StudyRoles]{api$admin$study_roles$list_access_tags()}}.
    update_access_tags = function(access_tags) {
        require_profiler_version("16.6.2", "access tag editing", private$api)
        checkmate::expect_list(access_tags,
                    types=c("numeric", "data.frame"),
                    names="named",
                    info="Paramter `access tags` should be provided as named list of access tags where names are
                    object ids and access tags are either provided as numeric vector of access tag ids
                    or an access tags data.frame.")
        purrr::walk(access_tags, check_access_tags)

        # ensure list of access tag ids
        body <- purrr::map(access_tags, get_access_tag_ids)
        # allows to hand in empty lists to wipe access tags as httr json encoding drops empty lists
        json_body <- jsonlite::toJSON(body, auto_unbox = TRUE)

        rest_response <- httr::POST(
          paste0(private$objects_url(), "/access-tags"),
          httr::content_type_json(),
          body = json_body,
          encode = 'raw',
          config = private$api$token
        )
        check_response(rest_response)
        invisible(self)
    },


    #' @description Add metadata to one or more Data Lake objects.
    #' @param ids Character vector or list of object IDs to which the metadata will be added.
    #' @param metadata Named list containing the metadata attributes and values to be added.
    #' Note that metadata values per attribute can be provided as a single character value or a vector.
    metadata_add = function(ids, metadata) {
        private$modify_metadata(ids, metadata = metadata, mode = 'add')
    },

    #' @description Set metadata of one or more Data Lake objects.
    #' @param ids Character vector or list of object IDs of which the specified metadata will be set.
    #' @param metadata Named list containing the metadata attributes and values to be set. By setting a metadata key
    #' to a value, possible previous values will be overwritten. Note that metadata values per attribute can be
    #' provided as a single character value or a vector.
    metadata_set = function(ids, metadata) {
        private$modify_metadata(ids, metadata = metadata, mode = 'set')
    },

    #' @description Remove specific metadata values from of one or more Data Lake objects.
    #' @param ids Character vector or list of object IDs of which the specified metadata will be removed.
    #' @param metadata Named list containing the metadata attributes and values to be removed. Note that metadata values
    #' per attribute can be provided as a single character value or a vector.
    metadata_remove = function(ids, metadata) {
        private$modify_metadata(ids, metadata = metadata, mode = 'remove')
    },

    #' @description Clear some or all metadata attributes associated to one or more Data Lake objects.
    #' @param ids Character vector or list of object IDs whose metadata attributes should be removed.
    #' @param keys Character vector containing metadata keys to be removed. If NULL is provided, all metadata keys
    #' associated with the given objects are cleared (default).
    metadata_clear = function(ids, keys = NULL) {
        if (is.null(keys)) {
            private$modify_metadata(ids, mode = 'clear')
        } else {
            md <- purrr::map(keys, ~ list())
            names(md) <- keys
            private$modify_metadata(ids, metadata = md, mode = 'set')
        }
    }
  )
)


data_lake <- function(api) {
    DataLake$new(api)
}